Status: Open

Priority: Normal

Assignee:

Category: Web Services clients/WMS

Pull Request or Patch supplied:No Resolution:

Easy fix?: No Copied to github as #: 21152

Description

Add support for WMS with time support to Add WMS layer.

http://docs.geoserver.org/latest/en/user/services/wms/time.html

http://mapserver.org/ogc/wms_time.html

Related issues:

Related to QGIS Application - Feature request # 8809: WMS/WMTS with dimension... Open 2013-10-09

History

#1 - 2015-07-06 11:55 AM - Anita Graser

- Subject changed from Add WMS-T support to Add WMS-T (time) support

#2 - 2015-07-08 09:33 AM - David Forrest

QGIS is currently able to access a WMST service as a plain WMS serivice by awkwardly embedding the TIME=????& parameter in the URL and not

letting the system use the URIs from the GetCapabilities document.    For an example see 

http://gis.stackexchange.com/questions/34667/does-qgis-have-wms-t-wms-with-time-support/153709#153709

Maybe one way to make this improvement easier would be making the Layer/Properties/General/Layer Source an editable field so a user could manually

update the optional parameters in the URL.  If editing a layer's WMS service prefix string was programmatically accessible, then a plugin could perhaps be

written to get the time and other optional dimensions from the capabilities document, and then provide UI tools to modify or control them.

As a sample use-case, the WMS-T service at 

http://mesonet.agron.iastate.edu/cgi-bin/wms/nexrad/n0r-t.cgi?TIME=2005-08-29T13:10:00Z&#38;LAYERS=nexrad-n0r-wmst&#38;TRANSPARENT=T

UE&#38;FORMAT=image%2Fpng&#38;SERVICE=WMS&#38;VERSION=1.1.1&#38;REQUEST=GetCapabilities looks like it should have about 1 million

rasters to play with.

#3 - 2015-07-09 07:51 AM - David Forrest

One can programmatically add and update a WMS-T layer like this:

urlWithParams =

'IgnoreGetFeatureInfoUrl=1&IgnoreGetMapUrl=1&contextualWMSLegend=0&crs=EPSG:3857&dpiMode=7&featureCount=10&format=image/png&layers=nexrad-n

g&layers=nexrad-n0r-wmst&styles=&url=http://mesonet.agron.iastate.edu/cgi-bin/wms/nexrad/n0r-t.cgi?TIME%3D2005-08-29T13:10:00Z%26LAYERS%3Dnexrad-n0r-wmst%26TRANSPARENT%3DTRUE%26VERSION%3D1.1.1%26'

urlWithParams2 = 'IgnoreGetFeatureInfoUrl=1&IgnoreGetMapUrl=1&contextual

YERS%3Dnexrad-n0r-wmst%26TRANSPARENT%3DTRUE%26VERSION%3D1.1.1%26'

urlWithParams2 =

'IgnoreGetFeatureInfoUrl=1&IgnoreGetMapUrl=1&contextualWMSLegend=0&crs=EPSG:3857&dpiMode=7&featureCount=10&format=image/png&layers=nexrad-n0r-wmst&styles=&url=http://mesonet.agron.iastate.edu/cgi-bin/wms/nexrad/n0r-t.cgi?TIME%3D2005-08-29T06:10:00Z%26LAYERS%3Dnexrad-n0r-wmst%26TRANSPARENT%3DTRUE%26VERSION%3D1.1.1%26'

rlayer = QgsRasterLayer(urlWithParams, 'radar WMST timeV2', 'wms')
QgsMapLayerRegistry.instance().addMapLayer(rlayer)

#update to different time
rlayer.data

2025-04-26 1/2

http://docs.geoserver.org/latest/en/user/services/wms/time.html
http://mapserver.org/ogc/wms_time.html
http://gis.stackexchange.com/questions/34667/does-qgis-have-wms-t-wms-with-time-support/153709#153709
http://mesonet.agron.iastate.edu/cgi-bin/wms/nexrad/n0r-t.cgi?TIME=2005-08-29T13:10:00Z&#38;LAYERS=nexrad-n0r-wmst&#38;TRANSPARENT=TRUE&#38;FORMAT=image%2Fpng&#38;SERVICE=WMS&#38;VERSION=1.1.1&#38;REQUEST=GetCapabilities
http://mesonet.agron.iastate.edu/cgi-bin/wms/nexrad/n0r-t.cgi?TIME=2005-08-29T13:10:00Z&#38;LAYERS=nexrad-n0r-wmst&#38;TRANSPARENT=TRUE&#38;FORMAT=image%2Fpng&#38;SERVICE=WMS&#38;VERSION=1.1.1&#38;REQUEST=GetCapabilities


g&layers=nexrad-n0r-wmst&styles=&url=http://mesonet.agron.iastate.edu/cgi-bin/wms/nexrad/n0r-t.cgi?TIME%3D2005-08-29T06:10:00Z%26LAYERS%3Dnexrad-n0r-wmst%26TRANSPARENT%3DTRUE%26VERSION%3D1.1.1%26'

rlayer = QgsRasterLayer(urlWithParams, 'radar WMST timeV2', 'wms')
QgsMapLayerRegistry.instance().addMapLayer(rlayer)

#update to different time
rlayer.dataProvider().setDataSourceUri(urlWithParams2)
rlayer.dataProvider().reloadData()
rlayer.triggerRepaint()



YERS%3Dnexrad-n0r-wmst%26TRANSPARENT%3DTRUE%26VERSION%3D1.1.1%26'

rlayer = QgsRasterLayer(urlWithParams, 'radar WMST timeV2', 'wms')

QgsMapLayerRegistry.instance().addMapLayer(rlayer)

#update to different time

rlayer.dataProvider().setDataSourceUri(urlWithParams2)

rlayer.dataProvider().reloadData()

rlayer.triggerRepaint()

#4 - 2015-10-16 03:50 AM - Nicolas Boisteault

Related issue #8809

#5 - 2017-05-01 12:47 AM - Giovanni Manghi

- Easy fix? set to No

#6 - 2017-09-18 03:51 PM - Anita Graser

- Description updated

TimeManager implements browsing WMS-T layers but it only helps for visualizations. Missing TIME parameters cause GetFeatureInfo requests to fail - or

more specifically - Geoserver will assume some default time value which is inconsistent with the currently visualized time in QGIS.

#7 - 2018-02-28 12:00 PM - Nicolas Boisteault

Issue still exists in QGIS 3.0.

Tests can be made with this 

http://sampleserver6.arcgisonline.com/arcgis/services/MultiDimensional_Sample/MapServer/WMSServer?request=GetCapabilities&#38;service=WMS
